/*==========bart quote selector 2.0===========*/
/* by Ric Crabbe                              */
/* Original version completed Fall, 1992      */
/* This version completed 27 Jul 1994         */
/*                                            */
/* (c) copyright 1994 Ric Crabbe              */
/* e-mail: cardo@cs.ucla.edu                  */
/* snail mail: Computer Science Department    */
/*             3436 Boelter Hall              */
/*             UCLA                           */
/*             Los Angeles, CA 90024          */
/*============================================*/

/*This program is free software; you can redistribute it and/or modify */
/*it under the terms of the GNU General Public License as published by */
/*the Free Software Foundation; either version 1, or (at your option)  */
/*any later version.                                                   */

/*This program is distributed in the hope that it will be useful,      */
/*but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*GNU General Public License for more details.                         */

/*You should have received a copy of the GNU General Public License    */
/*along with this program; if not, write to the Free Software          */
/*Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.            */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/time.h>

void usage(void);
void countq(void);

main(argc,argv)
int argc;
char **argv;
{
  int foo,filelen,spot;                         /*foo is the location of the target quote*/
                                                /*filelen is the number of quotes in file*/
                                                /*spot is the current location in file   */
  char *number = argv[1];                       /*text string that will become filelen   */
  char dead_str[100], live_str[100];            /*strings read in from file. dead_str    */
                                                /* will be discarded, live will hold quote*/

  if (argc != 2) {                              /*make sure we have the right # of args  */
    usage();
    exit(-1);
  }
  if (strcmp(number,"-c") == 0){                /*check to see if we want to count the   */
                                                /* quotes in the file                    */
    countq();
    exit(1);
  }
  filelen = strtol(number,NULL,10);            /*get the number of possible quotes*/
  if (filelen == 0){                           /*if number is not a number, then strtol */
    usage();                                   /* returns 0*/
    exit(-1);
  }
  spot = 0;
  srand(time(NULL));                           /*pick a random quote location*/
  foo = rand()%(filelen);


  while (spot != foo) {                        /*read each quote in order, keep track of */
    gets(dead_str);                            /*when a new quote begins. (blank line)   */
    if (dead_str[0] == '\0')
      spot++;
  }

  gets(live_str);                              /*we've made it to our desired quote.*/
  while (live_str[0] != '\0') {                /*read it in and print it out*/
    printf("%s\n",live_str);
    gets(live_str);
  }
}

void usage(void)
/*print out usage instructions and file formats*/
{
  fprintf(stderr,"Usage: cat <sigfile> | bart [-c] <filesize(in quotes)> > .signature\n");
  fprintf(stderr,"\n");
  fprintf(stderr,"bart reads the quotefile from stdin and prints the selected\n");
  fprintf(stderr,"quote to stdout.  For speed considerations, the number of quotes\n");
  fprintf(stderr,"in the quote file must be given as the single argument to bart.\n");
  fprintf(stderr,"if you don't know the number of quotes, use the '-c' option to\n");
  fprintf(stderr,"count them: cat <sigfile> | bart -c\n");
  fprintf(stderr,"\n");
  fprintf(stderr,"The format for the signature file is:\n");
  fprintf(stderr,"Quotation on 1 or more lines with no more than 100 char/line\n");
  fprintf(stderr,"followed by 1 single blank line.\n");
  fprintf(stderr,"This can be repeated for any number of quotes.\n");
  fprintf(stderr,"The last 2 lines of the file should be blank to signal the file end.\n");
}

void countq(void)
/*count the number of quotes in the quote file for later use as the argument*/
{
  int count = 0;                                /*number of quotes*/ 
  char throwaway[100];                          /*quote string read in*/
  int lastlineblank = 0;                        /*flag to detect if the end of the  */
                                                /* file is reached */
  int done = 0;                                 /*another flag*/

  while( !done ) {                              
    gets(throwaway);                            /*get the next string*/
    if (throwaway[0] == '\0'){                  /*if the string is empty, check to see */
      if (lastlineblank == 1)                   /* if the last one was empty too.  if  */
	done = 1;                               /* so, the end of the file is reached  */
      else                                      /* and we print the count.  Otherwise  */
	count++;                                /* the blank is a quote delimeter and  */
      lastlineblank = 1;                        /*we increment the count*/
    } else 
      lastlineblank = 0;
  }
  
  fprintf(stderr,"%d\n",count);
}
